package polyglot.ext.polyj.util;

import polyglot.types.*;
import polyglot.ext.polyj.types.*;

/**
 * Encapsulates the logic for buildling the names of methods
 * used to access arrays of parametric types.
 */
public interface ArrayAccessBinding {

    /**
     * The parametric type that this binding can construct
     * method names for.
     */
    ParamType param();

    /**
     * Name of method for length of type.
     */
    String length();

    /**
     * Name of method for accessing element of array of type.
     */
    String get();

    /**
     * Name of method for assigning to element of array of type.
     */
    String set();
}
