package polyglot.ext.polyj.util;

import polyglot.types.*;
import polyglot.ext.polyj.types.*;
import polyglot.ext.polyj.visit.*;

/**
 * Encapsulates the logic for buildling the names of methods
 * used to access arrays of parametric types.
 */
public class ArrayAccessBinding_c implements ArrayAccessBinding {
    protected String length;
    protected String get;
    protected String set;
    protected ParamType param;

    public ArrayAccessBinding_c(ParamType param, ClassType enclosing,
        PolyJTypeSystem ts) 
    {
        this.param = param;
        this.length = PolyJTranslator.adapterMethodName("a_len", param,
            enclosing, ts);
        this.get = PolyJTranslator.adapterMethodName("a_get", param,
            enclosing, ts);
        this.set = PolyJTranslator.adapterMethodName("a_set", param,
            enclosing, ts);
    }

    public String length() { return length; }
    public String get() { return get; }
    public String set() { return set; }
    public ParamType param() { return param; }
 }
