package polyglot.ext.pragma.parse;

import polyglot.ext.pragma.types.*;
import polyglot.ext.pragma.ast.*;
import polyglot.ast.*;
import polyglot.parse.*;
import polyglot.types.*;
import polyglot.util.*;

/**
 * Wrapper for a pragma parser.  This class should not need modified.
 */
public class PragmaParserWrapper implements ParserWrapper {
    protected Grm parser;

    public PragmaParserWrapper(Grm parser) {
        this.parser = parser;
    }

    public NodeFactory nodeFactory() {
        return parser.nf;
    }

    public TypeSystem typeSystem() {
        return parser.ts;
    }

    public void die(String message, Position pos) throws Exception {
        parser.die(message, pos);
    }

    public void die(Position pos) throws Exception {
        parser.die(pos);
    }
}

